#include "palabras.c"
#include "rw_mp.h"

//PC OK
void inc(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR)

{PC[0].uns++;
 Reg[0].sig++;
     if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
}
//PC OK
void dec(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR)

{PC[0].uns++;
 Reg[0].sig--;
     if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
}
//PC OK
void dec_z(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)

        {union tipo_palabra8 aux;
        union tipo_palabra16 dir;
        
        zero_page(PC, mp, &dir);
        leer_mp(&aux,mp,dir);
        
        aux.uns--;
        
        escribir_mp(&aux,mp,dir);
        
        if (aux.uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (aux.sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        
        }
//PC OK
void inc_z(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)

{union tipo_palabra8 aux;
        union tipo_palabra16 dir;
        
        zero_page(PC, mp, &dir);
        leer_mp(&aux,mp,dir);
        
        aux.uns++;
        
        escribir_mp(&aux,mp,dir);
        
    if (aux.uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (aux.sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
        
        }        
        
//PC OK        
void dec_dir(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)        
        
        {union tipo_palabra8 aux;
        union tipo_palabra16 dir;
        
        absoluto(PC, mp, &dir);
        leer_mp(&aux,mp,dir);
        
        aux.uns--;
        
        escribir_mp(&aux,mp,dir);
        
        if (aux.uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (aux.sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        
        }
        
        //PC OK
        void inc_dir(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)        
        
        {union tipo_palabra8 aux;
        union tipo_palabra16 dir;
        
        absoluto(PC, mp, &dir);
        leer_mp(&aux,mp,dir);
        
        aux.uns++;
        
        escribir_mp(&aux,mp,dir);
        
        if (aux.uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (aux.sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        
        }
        
  //PC OK      
void dec_indxz(union tipo_palabra16* PC, union tipo_palabra8* indice, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
    { 
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, indice, &dir2);
    
    leer_mp(&aux,mp,dir2); 
    
    aux.uns--;
        
        escribir_mp(&aux,mp,dir2);
        
        if (aux.uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (aux.sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        }
    //PC OK    
void inc_indxz(union tipo_palabra16* PC, union tipo_palabra8* indice, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
    {
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, indice, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    aux.uns++;
        
        escribir_mp(&aux,mp,dir2);
        
        if (aux.uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (aux.sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        }
     //PC OK   
void dec_ind(union tipo_palabra16* PC, union tipo_palabra8* indice, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
          {union tipo_palabra8 aux;
        union tipo_palabra16 dir;
        
        indexed(PC, mp, indice, &dir);
        leer_mp(&aux,mp,dir);
        
        aux.uns--;
        
        escribir_mp(&aux,mp,dir);
        
        if (aux.uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (aux.sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        }
    //PC OK    
void inc_ind(union tipo_palabra16* PC, union tipo_palabra8* indice, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
          {union tipo_palabra8 aux;
        union tipo_palabra16 dir;

        indexed(PC, mp, indice, &dir);
        leer_mp(&aux,mp,dir);
        
        aux.uns++;
        
        escribir_mp(&aux,mp,dir);
        
        if (aux.uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (aux.sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        }        
        
        
        
   inline void comun_sumar(union tipo_palabra8 aux, union tipo_palabra8* Reg,
                   union tipo_palabra8* SR)
   
        {
        //union tipo_palabra8 fake_A;
        union tipo_palabra16 fake_A;
        union tipo_palabra16 flag_c;
        
        fake_A.sig = aux.sig + Reg[0].sig + sacar_bit(0,SR[0]);
        
        //if ( (sacar_bit(7,Reg[0]) == sacar_bit(7,aux) ) && (sacar_bit(7,fake_A) != sacar_bit(7,aux)) )
        if(~(Reg[0].uns ^ aux.uns) & (Reg[0].uns ^ (fake_A.uns & 0xff)) & 0x80)
        {poner_bit(6,1,SR);
        } 
        
        else   {poner_bit(6,0,SR);}
        
        flag_c.uns = aux.uns + Reg[0].uns + sacar_bit(0,SR[0]);
          
        if ((flag_c.uns & 0xFF00) != 0)/*(( flag_c.uns-sacar_bit(0,SR[0])< aux.uns ) ||
            (flag_c.uns-sacar_bit(0,SR[0]) < Reg[0].uns ) )*/
        {poner_bit(0,1,SR);}
        
        else {poner_bit(0,0,SR);}
         
        
        Reg[0].uns = fake_A.uns & 0xff; 
         
        if (Reg[0].uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (Reg[0].sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
        }     
        
        
        
       //PC OK 
   void add_i(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
             union tipo_palabra8* mp)
   
       {
        union tipo_palabra8 aux;

        inmediato(PC, mp, &aux);
        comun_sumar(aux,Reg,SR);

        }        

        //PC OK
      void add_z(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
             union tipo_palabra8* mp)
             
        {
        union tipo_palabra8 aux;
        union tipo_palabra16 dir;                            
               
        zero_page(PC, mp, &dir);
        
        leer_mp(&aux,mp,dir);       
         comun_sumar(aux,Reg,SR);
        
        }        
        
     //PC OK   
void add_dir(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
           union tipo_palabra8* mp)
           
           
        {
        union tipo_palabra8 aux;
        union tipo_palabra16 dir;  

        absoluto(PC, mp, &dir);
        leer_mp(&aux,mp,dir);
        
        comun_sumar(aux,Reg,SR);
        
        }        
        
        
    //PC OK    
void add_indxz(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice, 
   union tipo_palabra8* SR, union tipo_palabra8* mp)
   
   {
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, indice, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    comun_sumar(aux,Reg,SR);
    
        }
        
       //PC OK 
   void add_ind(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
       {union tipo_palabra8 aux;
        union tipo_palabra16 dir;
        

        indexed(PC, mp, indice, &dir);
        leer_mp(&aux,mp,dir);
        
        comun_sumar(aux,Reg,SR);
        }
     //PC OK   
void adc_post_indx(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice,
                  union tipo_palabra8* SR,union tipo_palabra8* mp)
                
    {
     union tipo_palabra8 aux;
    union tipo_palabra16 dir3;
    
    
    
    post_index(PC,mp,indice,&dir3);
    leer_mp(&aux,mp,dir3);
    comun_sumar(aux,Reg,SR);
    }       
  inline void comun_restar(union tipo_palabra8 aux, union tipo_palabra8* Reg,
                   union tipo_palabra8* SR)  
                   
     {union tipo_palabra16 fake_A;

        
        fake_A.uns =  Reg[0].uns - aux.uns - ((SR[0].uns & sacar_bit(0,SR)) ? 0 : 1);
        
        if ((Reg[0].uns ^ aux.uns) & (Reg[0].uns ^ (fake_A.uns & 0xff)) & 0x80)
        {poner_bit(6,1,SR);} 
        
        else   {poner_bit(6,0,SR);}

        poner_bit(0,((fake_A.uns >> 8)+1)&1,SR);  

                 
        Reg[0].uns = fake_A.uns & 0xff; 
         
        if (Reg[0].uns == 0) poner_bit(1,1,SR);
        else poner_bit(1,0,SR);
   
        if (Reg[0].sig < 0) poner_bit(7,1,SR);
        else poner_bit(7,0,SR);
     
     }      



   //PC OK
   void sub_i(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
             union tipo_palabra8* mp)
   
       {//union tipo_palabra8 fake_A;
        union tipo_palabra8 aux;
        //unsigned char alter_c  = 0;

        inmediato(PC, mp, &aux);
        comun_restar(aux,Reg,SR);
                
        
        }      
        
    //PC OK
void sub_z(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
             union tipo_palabra8* mp)        
        
        {union tipo_palabra16 dir;  
        union tipo_palabra8 aux;                         
               
        zero_page(PC, mp, &dir);

        leer_mp(&aux,mp,dir);  
        comun_restar(aux,Reg,SR);
        
        }  
        
            
     //PC OK
void sub_dir(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
             union tipo_palabra8* mp)    
             
    {union tipo_palabra16 dir;  
        union tipo_palabra8 aux;
    
        
        
        absoluto(PC, mp, &dir);
        leer_mp(&aux,mp,dir);
        comun_restar(aux,Reg,SR);
        
         }  
        
        //PC OK
   void sub_indxz(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
       { 
       union tipo_palabra16 dir2;
        union tipo_palabra8 aux;  
        
        zindexed(PC, mp, indice, &dir2);
    
        leer_mp(&aux,mp,dir2);
        comun_restar(aux,Reg,SR);
        }  
        
       //PC OK 
  void sub_ind(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
        {union tipo_palabra16 dir;  
        union tipo_palabra8 aux;
         

        indexed(PC, mp, indice, &dir);
        leer_mp(&aux,mp,dir);
        comun_restar(aux,Reg,SR);
        
        }  
        
        
        //PC OK
        void sub_post_indx(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice,
                  union tipo_palabra8* SR,union tipo_palabra8* mp)
        
         
   {
    union tipo_palabra8 aux;    
    union tipo_palabra16 dir3;
 
    post_index(PC,mp,indice,&dir3);
    leer_mp(&aux,mp,dir3);
    
    comun_restar(aux,Reg,SR);
                  
    }  
