#include "palabras.c"
#include "rw_mp.h"

int se_ejecuto(union tipo_palabra8 IR, union tipo_palabra16 PC, union tipo_palabra8* mp)
    {
    
    union tipo_palabra8 aux; //Para poder imprimir algo
    union tipo_palabra16 aux_dir;
    
    switch (IR.uns)
 {
  case 0x00: //BRK A
  printf("BRK");
  break;
 
  //ASLs
  case 0x0A: //ASL A
  printf("ASL A");
  break;
  
  case 0x06: //ASL aa
   PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("ASL %x", aux.uns);
  break;
  
  case 0x16: //ASL aa, X
   PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("ASL %x,X", aux.uns);
  break;
  
  case 0x0E: //ASL aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("ASL $%x", aux_dir.uns);
  break;
  
  case 0x1E: //ASL aaaa, X
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("ASL $%x,X", aux_dir.uns);
  break;
  
    //LSRs
  case 0x4A: //LSR A
  printf("LSR A");
  break;
  case 0x46: //LSR aa
   PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("lSR %x", aux.uns);
  break;
  
  case 0x56: //LSR aa, X
   PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("lSR %x,X", aux.uns);
  break;
  
  case 0x4E: //LSR aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LSR $%x", aux_dir.uns);
  break;
  case 0x5E: //LSR aaaa, X
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LSR $%x,X", aux_dir.uns);
  break;
  
      //ROLs
  case 0x2A: //ROL A
  printf("ROL A");
  break;
  
  case 0x26: //ROL aa
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("ROL %x", aux.uns);
  break;
  
  case 0x36: //ROL aa, X
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("ROL %x,X", aux.uns);
  break;
  case 0x2E: //ROL aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("ROL $%x", aux_dir.uns);
  break;
  case 0x3E: //ROL aaaa, X
  printf("ROL aaaa, X");
  break;
  
     //RORs
  case 0x6A: //ROR A
  printf("ROR A");
  break;
  case 0x66: //ROR aa
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("ROR %x", aux.uns);
  break;
  case 0x76: //ROR aa, X
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("ROL %x,X", aux.uns);
  break;
  case 0x6E: //ROR aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("ROR $%x", aux_dir.uns);
  break;
  case 0x7E: //ROR aaaa, X
  printf("ROR aaaa, X");
  break;
 
 //CMP
 case 0xC9: //CMP #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("CMP #%x", aux.uns);
 break;
 
 case 0xC5: //CMP aa
  PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("CMP %x", aux.uns);
 break;
 
 case 0xD5: //CMP aa,X
  PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("CMP #%x,X", aux.uns);
 break; 
 
 case 0xCD: //CMP aaaa
 PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("CMP $%x", aux_dir.uns);
 break;
 case 0xDD: //CMP aaaa,X
 printf("CMP aaaa,X");
 break;
 case 0xD9: //CMP aaaa,X
 printf("CMP aaaa,Y");
 break;
 case 0xC1: //CMP (aa,X)
 PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("CMP (%x,X)", aux.uns);
 break;
 case 0xD1: //CMP (aa),Y
 PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("CMP (%x),Y", aux.uns);
 break;
 
 //CPX
 
 case 0xE0: //CPX #aa
  PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("CPX #%x", aux.uns);
 break;
 case 0xE4: //CPX aa
 PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("CPX %x", aux.uns);
 break;
 case 0xEC: //CPX aaaa
 PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("CPX $%x", aux_dir.uns);
 break;
 
  //CPY
 
 case 0xC0: //CPY #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("CPY #%x", aux.uns);
 break;
 case 0xC4: //CPY aa
 PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("CPY %x", aux.uns);
 break;
 case 0xCC: //CPY aaaa
 PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("CPY $%x", aux_dir.uns);
 break;
 
 
  //PUSHes
 
  case 0x48: //PHA
  printf("PHA");
  break;
  case 0x08: //PHP
  printf("PHP");
  break; 
  
  //POPes
  case 0x68:  //POP_A
  printf("PLA");
  break;
  case 0x28:  //POP_SR
  printf("PLP");
  break;
  
   //ANDs
  case 0x29: //and #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("AND #%x", aux.uns);
  break;
  case 0x25: //AND $aa
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("AND %x", aux.uns);
  break; 
  case 0x35: //AND $aa,X
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("AND %x,X", aux.uns);
  break;  
  case 0x2D: //AND $aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("AND $%x", aux_dir.uns);
  break; 
  case 0x3D: //AND $aaaa,X
  printf("AND aaaa,X");
  break;   
  case 0x39: //AND $aaaa,Y
  printf("AND aaaa,Y");
  break; 
  case 0x21: //AND ($aa,X)
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("AND (%x,X)", aux.uns);
  break;
  case 0x31: //AND ($aa), Y
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("AND (%x),Y", aux.uns);
  break;      
 
 //FIN ANDs
 
 //ORs
  case 0x09: //OR #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("OR #%x", aux.uns);
  break;
  case 0x05: //OR $aa
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("OR %x", aux.uns);
  break; 
  
  case 0x15: //OR $aa,X
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("OR %x,X", aux.uns);
  break;  
  case 0x0D: //OR $aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("OR $%x", aux_dir.uns);
  break; 
  case 0x1D: //OR $aaaa,X
  printf("OR aaaa,X");
  break;   
  case 0x19: //OR $aaaa,Y
  printf("OR aaaa,Y");
  break; 
  case 0x01: //OR ($aa,X)
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("OR (%x,Y)", aux.uns);
  break;
  case 0x11: //OR ($aa), Y
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("OR (%x),Y", aux.uns);
  break;
 
 
 //EORs
 
  case 0x49: //EOR #aa
   PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("EOR #%x", aux.uns);
  break;
  case 0x45: //EOR $aa
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("EOR %x", aux.uns);
  break; 
  case 0x55: //EOR $aa,X
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("EOR %x,X", aux.uns);
  break;  
  case 0x4D: //EOR $aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("EOR $%x", aux_dir.uns);
  break; 
  case 0x5D: //EOR $aaaa,X
  printf("EOR aaaa,X");
  break;   
  case 0x59: //EOR $aaaa,Y
  printf("EOR aaaa,Y");
  break; 
  case 0x41: //EOR ($aa,X)
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("EOR (%x,X)", aux.uns);
  break;
  case 0x51: //EOR ($aa), Y
  PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("EOR (%x),Y", aux.uns);
  break;
  
  //BIT
  case 0x24: //BIT aa
  printf("BIT aa");
  break;
  case 0x2C:  //BIT aaaa
  PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("BIT $%x", aux_dir.uns);
  break;
   
     
 //Saltos
 
  case 0x20: //jsr
  printf("JSR");
  break;
  case 0x40:
  printf("RTI");
  break;
  case 0x4C: //jmp $aaaa
  printf("JMP aaaa");
  break;
  case 0x6C: //(jmp $aaaa)
  printf("JMP (aaaa)");
  break;
  case 0x60:
  printf("RTS");
  break;
  
   case 0x78: //SEI
   printf("SEI");
   break;
   
   case 0xF8: //SED
   printf("SED");
   break; 
   
   case 0x38: //SEC
   printf("SEC");
   break; 
   
   case 0x18: //CLC
   printf("CLC");
   break;
   

   
   
   case 0x90: //BCC
   printf("BCC");
   break;  
   case 0xB0: //BCS
   printf("BCS");
   break;
   case 0xF0: //BEQ
   printf("BEQ");
   break;
   case 0x30: //BMI
   printf("BMI");
   break;  
   case 0xD0: //BNE
   printf("BNE");
   break;
   case 0x10: //BPL
   printf("BPL");
   break;
   case 0x50: //BVC
   printf("BVC");
   break;
   case 0x70: //BVS
   printf("BVS");
   break;
   
   case 0xD8: //CLD
   printf("CLD");
   break; 
   
   case 0x58: //CLI
   printf("CLI");
   break;
   
   case 0xB8: //CLV
   printf("CLV");
   break;  
 
   case 0x86: //STX $aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STX %x", aux.uns);
   break;
   case 0x8E: //STX $aaaa
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("STX $%x", aux_dir.uns);
   break;
   
   case 0x84: //STY $aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STY %x", aux.uns);
   break;
   
   case 0x8C: //STY $aaaa
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("STY $%x", aux_dir.uns);
   break;
   
   case 0x81: //STA ($aa,X)
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STA (%x,X)", aux.uns);
   break;
   
   case 0x85: //STA $aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STA %x", aux.uns);
   break;
   
   case 0x8D: //STA $aaaa
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("STA $%x", aux_dir.uns);
   break;
   
   case 0x91: //STA ($aa),Y
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STA (%x),Y", aux.uns);
   break;
   
   case 0x96: //STX $aa,Y
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STX %x,Y", aux.uns);
   break;
   case 0x95: //STA $aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STA %x,X", aux.uns);
   break; 
   case 0x94: //STY $aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("STY %x,X", aux.uns);
   break;   
   
   case 0x99: //STA $aaaa,Y
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("STA $%x,Y", aux_dir.uns);
   break; 
   
   case 0x9D: //STA $aaaa,X
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("STA $%x,X", aux_dir.uns);
   break;
   
   case 0xAA: //TAX
   printf("TAX");
   break;
   case 0xA8: //TAY
   printf("TAY");
   break;
   case 0x8A: //TXA
   printf("TXA");
   break;
   case 0x98: //TYA
   printf("TYA");
   break;
   case 0xBA: //TSX
   printf("TSX");
   break;
   case 0x9A: //TXS
   printf("TXS");
   break;
   
  
   case 0xA9: //LDA #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("LDA #%x", aux.uns);
   break;
   case 0xA5: //LDA $aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDA %x", aux.uns);
   break;
   case 0xB5: //LDA $aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDA %x,X", aux.uns);
   break;    
   case 0xAD: //LDA $aaaa
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LDA $%x", aux_dir.uns);
   break;
   
   case 0xB9: //LDA $aaaa,Y
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LDA $%x,Y", aux_dir.uns);
   break; 
   case 0xBD: //LDA $aaaa,X
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LDA $%x,X", aux_dir.uns);
   break;
   case 0xA1: //LDA ($aa,X)
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDA (%x,X)", aux.uns);
   break;
   case 0xB1: //LDA ($aa), Y
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDA (%x),Y", aux.uns);
   break;
   
   case 0xA2: //LDX #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("LDX #%x", aux.uns);
   break;    
   case 0xA6: //LDX $aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDX %x", aux.uns);
   break;   
   case 0xB6: //LDX $aa,Y
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDX %x,Y", aux.uns);
   break; 
           
   case 0xAE: //LDX $aaaa
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LDX $%x", aux_dir.uns);
   break;
   
   case 0xBE: //LDX $aaaa, Y
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LDX $%x,Y", aux_dir.uns);
   break;             
    
   case 0xA0: //LDY #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("LDY #%x", aux.uns);
   break;    
   case 0xA4: //LDY $aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDY %x", aux.uns);
   break;   
   case 0xB4: //LDY $aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("LDY %x,X", aux.uns);
   
   break;         
   case 0xAC: //LDY $aaaa
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LDY $%x", aux_dir.uns);
   
   break;
   case 0xBC: //LDY $aaaa, X
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("LDY $%x,X", aux_dir.uns);
   break;

   
   case 0xEA: //NOP
   printf("NOP");
   break;
   case 0x1A: //NOP
   printf("NOP");
   break;
   case 0x3A: //NOP
   printf("NOP");
   break;
   case 0x5A: //NOP
   printf("NOP");
   break;
   case 0x7A: //NOP
   printf("NOP");
   break;
   case 0xDA: //NOP
   printf("NOP");
   break;
   case 0xFA : //NOP
   printf("NOP"); 
   
                                       
   break;
   case 0x0C: //NOP
   printf("NOP");
   break;
   case 0x1C: //NOP
   printf("NOP");
   break;
   case 0x3C: //NOP
   printf("NOP");
   break;
   case 0x5C: //NOP
   printf("NOP");
   break;
   case 0x7C: //NOP
   printf("NOP");
   break;
   case 0xDC: //NOP
   printf("NOP");
   break;
   case 0xFC: //NOP
      printf("NOP");
   break; 
   
   case 0x80: //NOP
   printf("NOP");
   break; 
   case 0x82: //NOP
   printf("NOP");
   break;
   case 0x89: //NOP
   printf("NOP");
   break;
   case 0xC2:
   printf("NOP");
   break;    
   case 0xE2: //NOP
   printf("NOP");
   break;        
   case 0x04: //NOP
   printf("NOP");
   break;       
   case 0x14: //NOP
   printf("NOP");
   break;   
   case 0x34: //NOP
   printf("NOP");
   break;    
   case 0x54: //NOP
   printf("NOP");
   break;   
   case 0x74: //NOP
   printf("NOP");
   break;   
   case 0xD4: //NOP
   printf("NOP");
   break;   
   case 0xF4 : //NOP
   printf("NOP");
   break;                                                 
   
   
   case 0xE8: //INX
   printf("INX");
   break;
   case 0xC8: //INY
   printf("INY");
   break; 
   
      //SBC
   case 0xE9: //SBC #aa
 PC.uns--;
 leer_mp(&aux,mp,PC);
 printf("SBC #%x", aux.uns);
   break;
   case 0xE5: //SBC aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("SBC %x", aux.uns);
   break;
   case 0xED: //SBC aaaa
   printf("SBC aaaa");
   break;
   case 0x75: //SBC aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("SBC %x,X", aux.uns);
   break;
   case 0x7D: //SBC aaaa,X
   printf("SBC aaaa,X");
   break;   
   
   //ADC
   case 0x69: //ADC #aa
    PC.uns--;
    leer_mp(&aux,mp,PC);
    printf("ADC #%x", aux.uns);
   break;
   case 0x65: //ADC aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("ADC %x", aux.uns);
   break;
   case 0x6D: //ADC aaaa
   printf("ADC aaaa");
   break;
   case 0xF5: //ADC aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("ADC %x,X", aux.uns);
   break;
   case 0xFD: //ADC aaaa,X
   printf("ADC aaaa,X");
   break;   
   
   //INC
   
   case 0xE6: //INC aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("INC %x", aux.uns);
   break;
   case 0xF6: //INC aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("INC %x,X", aux.uns);
   break;
   case 0xEE: //INC aaaa
   printf("INC aaaa");
   break;
   case 0xFE: //INC aaaa,X
   printf("INC aaaa, X");
   break;
   
   //DEC
   
   case 0xC6: //DEC aa
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("DEC %x", aux.uns);
   break;
   case 0xD6: //DEC aa,X
   PC.uns--;
  leer_mp(&aux,mp,PC);
  printf("DEC %x,X", aux.uns);
   break;
   case 0xCE: //DEC aaaa
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = aux.uns;
   PC.uns--;
   leer_mp(&aux,mp,PC);
   aux_dir.uns = 256*aux_dir.uns + aux.uns;
   printf("DEC $%x", aux_dir.uns);
   break;
   case 0xDE: //DEC aaaa,X
   printf("DEC aaaa,X");
   break;
  
   
   case 0x88: //DEY
   printf("DEY");
   break;
   case 0xCA: //DEX
   printf("DEX");
   break; 
   
   //LOS OPCODES MISTERIOSOS
   //ASOs (SLO)
  case 0x07: //ASO aa
  printf("ASO aa");
  break;
  case 0x17: //ASO aa, X
  printf("ASO aa, X");
  break;
  case 0x0F: //ASO aaaa
  printf ("ASO aaaa");
  break;
  case 0x1F: //ASO aaaa, X
  printf("ASO aaaa, X");
  break;
  case 0x1B: //ASO aaaa, Y
  printf("ASO aaaa, Y");
  break;
  
    //RLAs
  case 0x27: //RLA aa
  printf("RLA aa");
  break;
  case 0x37: //RLA aa, X
  printf("RLA aa, X");
  break;
  case 0x2F: //RLA aaaa
  printf("RLA aaaa");
  break;
  case 0x3F: //RLA aaaa, X
  printf("RLA aaaa, X");
  break;
  case 0x3B: //RLA aaaa, Y
  printf("RLA aaaa, Y");
  break;
    
  default: 
  printf("MAL MAL");
  break;
  }  
    
    }
    
void trazador(int *halt,union tipo_palabra8* IR, union tipo_palabra16* PC, union tipo_palabra8* SP
             ,union tipo_palabra8* X, union tipo_palabra8* Y, union tipo_palabra8* A
             ,union tipo_palabra8* SR, union tipo_palabra8* mp, int* brk, unsigned int* bp,
             unsigned long ciclo, unsigned char line, int* traza)
             
     {int i;
      int j;
      int fin = 0;
      char basura;
      char comand;
      unsigned int p1;
      unsigned char p2;
      unsigned int wrt[2]; //Prepuciano totaaaaaal
      unsigned char sprite;
      //unsigned long 
      
      int mostrar()
  {
   printf("---------------------------------------------------------------------------\n");
   printf("N Inst: %i\n", ciclo/4);
   printf("Drawing scanline n: %i\n", line);
   printf("PC: %p", PC[0].uns);
   printf("   SR: %p", SR[0].uns);
   printf("   SP: %p", SP[0].uns);
   printf("   Last Instrucion: ");
   se_ejecuto(IR[0],PC[0],mp);
   printf("\n\n");
   printf("X: %p", X[0].uns);
   printf("    Y: %p\n", Y[0].uns);
   printf("A: %p\n\n\n", A[0].uns);
  } 
        
 int informe_sprite(unsigned char num, union tipo_palabra8* mp)
    {
     printf("Sprite #%i Info:\n", num);
     printf("X: %i  Y: %i\n", mp[0x903 + 4*num].uns, mp[0x900 +4*num].uns);
     printf("Tile Index #%i\n\n", mp[0x901 + 4*num].uns);
    
            
    }        
          
           
            
             
              
               
                 
      
   //   printf("%x %x\n", PC[0].uns, bp[2]);
      
      bp[1]--; //Quedan menos instrucciones por ejecutar.
      
      if ((bp[0] == 1) && ((bp[2] & 0xFFFF) != PC[0].uns)) fin = 1; //Si no se alcanza el pto
      
      if ((bp[2] & 0xFFFF) == PC[0].uns) {fin = 0; bp[0] = 0;}
      else 
       {if (bp[1] < 0) ;                                                                                                    //ruptura pos nos piramos
        else if (bp[1] == 1) bp[0] = 0; //Cutrada para que se imprima 
        else if (bp[1] == 0) {fin = 0;}
        }
        
      if (bp[0] == 0) mostrar();  
        
      while (fin == 0)
       {
        printf("EmilNES>");
        scanf("%c",&comand);
        
        //comand = 0xA;
        
        if (comand == 0xA) (fin = 1);
        else if (comand == 'q') 
            {halt[0] = 1;
             fin = 1;
             }
        
        
        else if (comand == 'r') 
            {traza[0] = 0;
             fin = 1;
             
             while (comand != 0xA)
                {scanf("%c",&comand);}
             
             }          
         
                          
        else if (comand == 'v')//COMANDO v
            {scanf("%x1\n",&p1);
             scanf("%c",&comand);
             while (comand != 0xA)
                {scanf("%c",&comand);} //para kitar el intro
             fin = 0;
             
             for (i = 0; i < 8; i++)
               {for (j = 0; j < 16; j++)
                {
                if (j == 0) 
                 {if (mp[p1 + j + 16*i].uns < 0x10)
                  printf("%x:  %x", p1+16*i,mp[p1 + j + 16*i].uns);
                  else printf("%x: %x", p1+16*i,mp[p1 + j + 16*i].uns);
                 }
                else if (j == 15) 
                {if (mp[p1 + j + 16*i].uns < 0x10)
                  printf("  %x\n", mp[p1 + j + 16*i].uns);
                  else printf(" %x\n", mp[p1 + j + 16*i].uns);
                }
                else 
                 {if (mp[p1 + j + 16*i].uns < 0x10)
                  printf("  %x", mp[p1 + j + 16*i].uns);
                  else printf(" %x", mp[p1 + j + 16*i].uns);
                 }
                }
               } 
            }
        
        else if (comand == 'e') 
            {bp[0] = 1; //No interactivo
             scanf("%i1%c\n", &bp[1], &comand); //Cuantas instrucciones
             while (comand != 0xA)
                {scanf("%c",&comand);} //para kitar el intro
             fin = 1;
             }
                  
        else if (comand == 'p') 
            {bp[0] = 1; //No interactivo
             scanf("%x1%c\n", &bp[2], &comand); //Cuantas instrucciones
                    
             while (comand != 0xA)
                {scanf("%c",&comand);} //para kitar el intro   
             fin = 0;
             } 
             
         else if (comand == 's') 
            {//bp[0] = 1; //No interactivo
             scanf("%i1%c\n", &sprite, &comand); //Cuantas instrucciones
             
             while (comand != 0xA)
                {scanf("%c",&comand);} //para kitar el intro
             fin = 0;
             
             informe_sprite(sprite,mp);
             }          
                      
             
        else if (comand == 'w') //write 
            {
             
             scanf("%x%c%x1\n", &wrt[0], &comand, &p2); //Cuantas instrucciones
             mp[wrt[0]].uns = p2;
             while (comand != 0xA)
                {scanf("%c",&comand);} //para kitar el intro
             fin = 0;
             }                    
        
                                                
         else if (comand == 'h') 
            {
              
              printf("\nEmilNES's Debugger Help\n");
              printf("\n   e <num_instrucions>: Execute n instructions\n");  
              printf("   h: Help\n");
              printf("   p <breakpoint>: Set a breakpoint\n");
              printf("   q: Quit\n");
              printf("   r: Leave trace mode and run\n");
              printf("   s <number>: Prints sprite's information\n");
              printf("   v <dir_org>: View memory\n");
              printf("   w <dir> <value>: Writes val at dir\n\n");
              
              fin = 0;           
              
              while (comand != 0xA)
                {scanf("%c",&comand);}
                                          
             }    
                                                                                                                                                                        
        else 
             {printf("Unknown Command\n");
             fin = 0;
             while (comand != 0xA)
                {scanf("%c",&comand);} //para kitar el intro
             }
        ;}
     
     }                
