#include "palabras.c"
#include "rw_mp.h"

//PC OK
int and_inm(union tipo_palabra16* PC, union tipo_palabra8* Reg,
            union tipo_palabra8* SR, union tipo_palabra8* mp)
            
            {union tipo_palabra8 dato;
            
             inmediato(PC, mp, &dato);
             
             Reg[0].uns = Reg[0].uns & dato.uns;
             
             if (Reg[0].uns == 0) poner_bit(1,1,SR);
             else poner_bit(1,0,SR);
   
             if (Reg[0].sig < 0) poner_bit(7,1,SR);
             else poner_bit(7,0,SR);
            
            
            }
//PC OK            
   int and_zero(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
                union tipo_palabra8* mp)
            
    {//union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zero_page(PC, mp, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    Reg[0].uns = Reg[0].uns & aux.uns;
     
    
    if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
    }           
    //PC OK
    int and_indxz(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice,
                  union tipo_palabra8* SR, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, indice, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    Reg[0].uns = Reg[0].uns & aux.uns;
    
    if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
   }
   //PC OK
   int fand(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR, 
        union tipo_palabra8* mp)
        
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    

    absoluto(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);

    
    X[0].uns = X[0].uns & aux.uns;
    
    if (X[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (X[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
                          
    }           
    //PC OK
    int and_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice,
        union tipo_palabra8* SR, union tipo_palabra8* mp)
        {union tipo_palabra8 dir;
         union tipo_palabra16 dir2;
    

    indexed(PC, mp, indice, &dir2);
    leer_mp(&dir,mp,dir2);
    
    dato[0].uns = dato[0].uns & dir.uns;  
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
                
        }         
        
 
     //PC OK
int and_pre_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, 
                 union tipo_palabra8* SR,union tipo_palabra8* mp)                    
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    dpre_index(PC, mp, indice, &dir3);
    
    leer_mp(&dir,mp,dir3);
    
    dato[0].uns = dato[0].uns & dir.uns;  
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
     
     }            
     
       //PC OK         
     int and_post_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice,
                  union tipo_palabra8* SR,union tipo_palabra8* mp)
                
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    
    post_index(PC,mp,indice,&dir3);
    leer_mp(&dir,mp,dir3);

    dato[0].uns = dato[0].uns & dir.uns;     
   
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);   
    
     } 
    
 
   //OR
   
     //PC OK
  int or_inm(union tipo_palabra16* PC, union tipo_palabra8* Reg,
            union tipo_palabra8* SR, union tipo_palabra8* mp)
            
            {union tipo_palabra8 dato;
            
             inmediato(PC, mp, &dato);
             
             Reg[0].uns = Reg[0].uns | dato.uns;
             
             if (Reg[0].uns == 0) poner_bit(1,1,SR);
             else poner_bit(1,0,SR);
   
             if (Reg[0].sig < 0) poner_bit(7,1,SR);
             else poner_bit(7,0,SR);
            
            
            }
       
            //PC OK     
   int or_zero(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
                union tipo_palabra8* mp)
            
    {//union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zero_page(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);
    
    Reg[0].uns = Reg[0].uns | aux.uns;
    
    
    if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
    }           
    //PC OK
    int or_indxz(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice,
                  union tipo_palabra8* SR, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, indice, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    Reg[0].uns = Reg[0].uns | aux.uns;
    
    if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
   }
   //PC OK
   int f_or(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR, 
        union tipo_palabra8* mp)
        
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    absoluto(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);
    
    
    X[0].uns = X[0].uns | aux.uns;
    
    if (X[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (X[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
                          
    }           
    //PC OK
    int or_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice,
        union tipo_palabra8* SR, union tipo_palabra8* mp)
        {union tipo_palabra8 dir;
         union tipo_palabra16 dir2;
    
    indexed(PC, mp, indice, &dir2);
    leer_mp(&dir,mp,dir2);
    
    dato[0].uns = dato[0].uns | dir.uns;  
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
                
        }         
        
 
     //PC OK
int or_pre_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, 
                 union tipo_palabra8* SR,union tipo_palabra8* mp)                    
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    dpre_index(PC, mp, indice, &dir3);
    
    leer_mp(&dir,mp,dir3);
    
    dato[0].uns = dato[0].uns | dir.uns;  
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
     
     }            
     
      //PC OK          
     int or_post_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice,
                  union tipo_palabra8* SR,union tipo_palabra8* mp)
                
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    

    post_index(PC,mp,indice,&dir3);
    leer_mp(&dir,mp,dir3);

    dato[0].uns = dato[0].uns | dir.uns;     
   
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);   
    
     }         
    
    
    
    
    //EOR
    
    //PC OK
    int eor_inm(union tipo_palabra16* PC, union tipo_palabra8* Reg,
            union tipo_palabra8* SR, union tipo_palabra8* mp)
            
            {union tipo_palabra8 dato;
            
             inmediato(PC, mp, &dato);
             
             Reg[0].uns = Reg[0].uns ^ dato.uns;
             
             if (Reg[0].uns == 0) poner_bit(1,1,SR);
             else poner_bit(1,0,SR);
   
             if (Reg[0].sig < 0) poner_bit(7,1,SR);
             else poner_bit(7,0,SR);
            
            
            }
       
    //PC OK             
   int eor_zero(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
                union tipo_palabra8* mp)
            
    {//union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zero_page(PC, mp, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    Reg[0].uns = Reg[0].uns ^ aux.uns;
    
    
    if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
    }           
    //PC OK
    int eor_indxz(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* indice,
                  union tipo_palabra8* SR, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, indice, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    Reg[0].uns = Reg[0].uns ^ aux.uns;
    
    if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
   }
   //PC OK
   int eor(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR, 
        union tipo_palabra8* mp)
        
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    absoluto(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);
    
    X[0].uns = X[0].uns ^ aux.uns;
    
    if (X[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (X[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
                          
    }           
    //PC OK
    int eor_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice,
        union tipo_palabra8* SR, union tipo_palabra8* mp)
        {union tipo_palabra8 dir;
         union tipo_palabra16 dir2;
    
    indexed(PC, mp, indice, &dir2);
    leer_mp(&dir,mp,dir2);

    dato[0].uns = dato[0].uns ^ dir.uns;  
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
                
        }         
        
 
     //PC OK
int eor_pre_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, 
                 union tipo_palabra8* SR,union tipo_palabra8* mp)                    
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    dpre_index(PC, mp, indice, &dir3);
    
    leer_mp(&dir,mp,dir3);
    
    dato[0].uns = dato[0].uns ^ dir.uns;  
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
     
     }            
     
       //PC OK         
     int eor_post_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice,
                  union tipo_palabra8* SR,union tipo_palabra8* mp)
                
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    

    post_index(PC,mp,indice,&dir3);
    leer_mp(&dir,mp,dir3);

    dato[0].uns = dato[0].uns ^ dir.uns;     
   
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);   
    
     }         
    
    //PC OK
    int asl_a(union tipo_palabra16* PC, union tipo_palabra8* A, union tipo_palabra8* SR)
    
        {poner_bit(0,sacar_bit(7,A[0].uns),SR);
        
         A[0].uns = A[0].uns * 2;
        
         if (A[0].uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (A[0].sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         PC[0].uns++;
        
         }        
    //PC OK     
    int asl_z(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)
         
        {
         //union tipo_palabra8 dir;
         union tipo_palabra16 dir2;
         union tipo_palabra8 aux;
         
         
         zero_page(PC, mp, &dir2);
    
         leer_mp(&aux,mp,dir2); //En aux esta M
    
         poner_bit(0,sacar_bit(7,aux),SR);
        
         aux.uns = aux.uns * 2;
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
         }
     //PC OK    
int asl_xz(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)         
         
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, X, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    poner_bit(0,sacar_bit(7,aux),SR);
    
    aux.uns = aux.uns * 2;
        
        if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
    
   }
   
   //PC OK
   int asl(union tipo_palabra16* PC, union tipo_palabra8* SR,union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    absoluto(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);
    
    
    poner_bit(0,sacar_bit(7,aux),SR);
    
    aux.uns = aux.uns * 2;
        
        if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
                          
    }
//PC OK
int asl_indx(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)


    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    
    indexed(PC, mp, X, &dir2);
    leer_mp(&dir,mp,dir2);
    
    poner_bit(0,sacar_bit(7,dir),SR);
      
    dir.uns = dir.uns * 2;
        
        if (dir.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (dir.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&dir,mp,dir2); //Lo devolvemos a casita 
                
    }   
    
     //PC OK
 int asl_pre_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, 
                 union tipo_palabra8* SR,union tipo_palabra8* mp)                    
    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    dpre_index(PC, mp, indice, &dir3);
    
    leer_mp(&dir,mp,dir3); 
     
     
    poner_bit(0,sacar_bit(7,dir),SR);
      
    dir.uns = dir.uns * 2;
        
        if (dir.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (dir.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&dir,mp,dir2); //Lo devolvemos a casita 
         
   }
     

     

    //PC OK
    int lsr_a(union tipo_palabra16* PC, union tipo_palabra8* A, union tipo_palabra8* SR)
    
        {poner_bit(0,sacar_bit(0,A[0].uns),SR);
        
         A[0].uns = A[0].uns >> 1;
        
         if (A[0].uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (A[0].sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
        
         PC[0].uns++;
        
         }        
    //PC OK     
    int lsr_z(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)
         
        {
         //union tipo_palabra8 dir;
         union tipo_palabra16 dir2;
         union tipo_palabra8 aux;
         
         zero_page(PC, mp, &dir2);
         
         leer_mp(&aux,mp,dir2); //En aux esta M
    
         poner_bit(0,sacar_bit(0,aux),SR);
        
         aux.uns = aux.uns >> 1;
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
         }
     //PC OK    
int lsr_xz(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)         
         
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    
    zindexed(PC, mp, X, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    poner_bit(0,sacar_bit(0,aux),SR);
    
    aux.uns = aux.uns >> 1;
        
        if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
    
   }
   
   //PC OK
   int lsr(union tipo_palabra16* PC, union tipo_palabra8* SR,union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;

    absoluto(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);

    
    poner_bit(0,sacar_bit(0,aux),SR);
    
    aux.uns = aux.uns >> 1;
        
        if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
                          
    }
//PC OK
int lsr_indx(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)


    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    

    indexed(PC, mp, X, &dir2);
    leer_mp(&dir,mp,dir2);
    
    poner_bit(0,sacar_bit(0,dir),SR);
      
    dir.uns = dir.uns >> 1;
        
        if (dir.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (dir.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
          
         escribir_mp(&dir,mp,dir2); //Lo devolvemos a casita 
                
    }    
    
    
    //ROL
    //PC OK
    int rol_a(union tipo_palabra16* PC, union tipo_palabra8* A, union tipo_palabra8* SR)
    
        {unsigned char val;
        
         PC[0].uns++;
        
         val = sacar_bit(7,A[0].uns);
        
         A[0].uns = A[0].uns<< 1;  //modficiado para agilizar
         A[0].uns = A[0].uns + sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (A[0].uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (A[0].sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
        
         }        
    //PC OK     
    int rol_z(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)
         
        {
         //union tipo_palabra8 dir;
         union tipo_palabra16 dir2;
         union tipo_palabra8 aux;
         unsigned char val;
         
         zero_page(PC, mp, &dir2);
         leer_mp(&aux,mp,dir2); //En aux esta M
        
         
        
         val = sacar_bit(7,aux.uns);
        
         aux.uns = aux.uns<< 1;  //modficiado para agilizar
         aux.uns = aux.uns + sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
         }
     //PC OK    
int rol_xz(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)         
         
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    unsigned char val;
    
    zindexed(PC, mp, X, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    
        
         val = sacar_bit(7,aux.uns);
        
         aux.uns = aux.uns<< 1;  //modficiado para agilizar
         aux.uns = aux.uns + sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
    
   }
   
   //PC OK
   int rol(union tipo_palabra16* PC, union tipo_palabra8* SR,union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
        
    unsigned char val;

    absoluto(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);
    

        
         val = sacar_bit(7,aux.uns);
        
         aux.uns = aux.uns<< 1;  //modficiado para agilizar
         aux.uns = aux.uns + sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
                          
    }
     //PC OK
int rol_indx(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)


    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    unsigned char val; 
    indexed(PC, mp, X, &dir2);
    leer_mp(&dir,mp,dir2);
    
   
        
         val = sacar_bit(7,dir.uns);
        
         dir.uns = dir.uns<< 1;  //modficiado para agilizar
         dir.uns = dir.uns + sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (dir.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (dir.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&dir,mp,dir2); //Lo devolvemos a casita 
                
    }    
    
    
    //ROR
    
    //PC OK
        int ror_a(union tipo_palabra16* PC, union tipo_palabra8* A, union tipo_palabra8* SR)
    
        {unsigned char val;
        
         PC[0].uns++;
        
         val = sacar_bit(0,A[0].uns);
        
         A[0].uns = A[0].uns >> 1;  //modficiado para agilizar
         A[0].uns = A[0].uns + 128*sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
        
         if (A[0].uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (A[0].sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
        
         }        
         //PC OK
    int ror_z(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* mp)
         
        {
         //union tipo_palabra8 dir;
         union tipo_palabra16 dir2;
         union tipo_palabra8 aux;
         unsigned char val;
         
         zero_page(PC, mp, &dir2);
         leer_mp(&aux,mp,dir2); //En aux esta M
        
         
        
         val = sacar_bit(0,aux.uns);
        
         aux.uns = aux.uns >> 1;  //modficiado para agilizar
         aux.uns = aux.uns + 128*sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
         }
    //PC OK     
int ror_xz(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)         
         
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
    unsigned char val;
    
    zindexed(PC, mp, X, &dir2);
    
    leer_mp(&aux,mp,dir2);
    
    
        
         val = sacar_bit(0,aux.uns);
        
         aux.uns = aux.uns >> 1;  //modficiado para agilizar
         aux.uns = aux.uns + 128*sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
    
   }
   
   //PC OK
   int ror(union tipo_palabra16* PC, union tipo_palabra8* SR,union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra8 aux;
      unsigned char val;

    absoluto(PC, mp, &dir2);
    leer_mp(&aux,mp,dir2);

    
 
        
         val = sacar_bit(0,aux.uns);
        
         aux.uns = aux.uns >> 1;  //modficiado para agilizar
         aux.uns = aux.uns + 128*sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (aux.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (aux.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&aux,mp,dir2); //Lo devolvemos a casita 
                          
    }
    //PC OK
int ror_indx(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR,
           union tipo_palabra8* mp)


    {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    unsigned char val;

    indexed(PC, mp, X, &dir2);
    leer_mp(&dir,mp,dir2);
    
    
        
         val = sacar_bit(0,dir.uns);
        
         dir.uns = dir.uns >> 1;  //modficiado para agilizar
         dir.uns = dir.uns + 128*sacar_bit(0,SR[0].uns);
         poner_bit(0,val,SR);
        
         if (dir.uns == 0) poner_bit(1,1,SR);
         else poner_bit(1,0,SR);
   
         if (dir.sig < 0) poner_bit(7,1,SR);
         else poner_bit(7,0,SR); 
         
         escribir_mp(&dir,mp,dir2); //Lo devolvemos a casita 
                
    }  
