#include "palabras.c"
#include "rw_mp.h"
//PC OK
int stx_zero(union tipo_palabra16* PC, union tipo_palabra8* X,union tipo_palabra8* mp)

   {//union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    
    zero_page(PC, mp, &dir2);
    escribir_mp(X,mp,dir2);
    
    
   }
//PC OK   
   int ldx_zero(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SR,
             union tipo_palabra8* mp)
             
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    
    zero_page(PC, mp, &dir2);
    leer_mp(Reg,mp,dir2);
    
    if (Reg[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (Reg[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    
                     
   }          
   
//PC OK   
   int stx(union tipo_palabra16* PC, union tipo_palabra8* X,union tipo_palabra8* mp)

   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    
    absoluto(PC, mp, &dir2);
    escribir_mp(X,mp,dir2);

   }

//PC OK   
  int ldx(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR, union tipo_palabra8* mp)

   {union tipo_palabra16 dir2;
    
    
    absoluto(PC, mp, &dir2);
    leer_mp(X,mp,dir2);
    
    if (X[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (X[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
   }
   
   //PC OK
     int ldi(union tipo_palabra16* PC, union tipo_palabra8* X, union tipo_palabra8* SR, union tipo_palabra8* mp)

   {union tipo_palabra8 dir;
    
    
    //PC[0].uns++;           //Se lee la parte baja
    //leer_mp(&dir,mp,PC[0]);
    //PC[0].uns = PC[0].uns + 1;
    
    inmediato(PC, mp, &dir);
    
    X[0] = dir;

    
    
    if (X[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (X[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
   }
   
   //PC OK
   int stx_indxZ(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, union tipo_palabra8* mp)
    
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    

    zindexed(PC, mp, indice, &dir2);
    
    escribir_mp(dato,mp,dir2);
    //PC[0].uns++; 
   }
   //PC OK
   int ld_indxZ(union tipo_palabra16* PC, union tipo_palabra8* dato,union tipo_palabra8* indice,
              union tipo_palabra8* SR, union tipo_palabra8* mp)
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    
    zindexed(PC, mp, indice, &dir2);
    
    leer_mp(dato,mp,dir2);
    //PC[0].uns++; 
   
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);   
   }                      
   
   //PC OK
   int stx_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    /*
    PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = (dir.uns + indice[0].uns);// % 256;
    
    PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = (256*dir.uns + dir2.uns) % 0x10000;  //NESTRESS
    */
    indexed(PC, mp, indice, &dir2);
    escribir_mp(dato,mp,dir2);
    //PC[0].uns++; 
   }
   
   //PC OK
   int ldx_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, 
                union tipo_palabra8* SR, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    /*
    PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = (dir.uns + indice[0].uns);// % 256;
    
    PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = (256*dir.uns + dir2.uns) % 0x10000;  //NESTRESS
    */
    indexed(PC, mp, indice, &dir2);
    leer_mp(dato,mp,dir2);
//    PC[0].uns++; 
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
   }
   
   //PC OK
   int stx_pre_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    /*PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = (dir.uns + indice[0].uns) % 256; //CAMBIO PARA NESTRESS
    
    //En la dir 2 tenemos q sacar los 2bytes de dir.           
                                     
    leer_mp(&dir,mp,dir2);
    dir3.uns = dir.uns;
    dir2.uns++; 
    */
    dpre_index(PC, mp, indice, &dir3);
    
    escribir_mp(dato,mp,dir3);
    //PC[0].uns++; 
   }
   //PC OK
   int ldx_pre_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, 
                    union tipo_palabra8* SR, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    //printf("%p\n", PC[0].uns);
    //system("pause");
    
    /*PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = (dir.uns + indice[0].uns) % 256; //CAMBIO PARA NESTRESS
               
    leer_mp(&dir,mp,dir2);
    dir3.uns = dir.uns;
    dir2.uns++; 
    
    leer_mp(&dir,mp,dir2);
    dir3.uns = 256*dir.uns + dir3.uns;
    */
    dpre_index(PC, mp, indice, &dir3);
    leer_mp(dato,mp,dir3);
    //PC[0].uns++; 
    
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
   }
   
   //PC OK
   int stx_post_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice, union tipo_palabra8* mp)
   
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    /*PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = dir.uns;
               
    leer_mp(&dir,mp,dir2);
    dir3.uns = (dir.uns + indice[0].uns);//%256; //Parte baja la dir
    
    dir2.uns++;
    leer_mp(&dir,mp,dir2); //Parte alta
    dir3.uns = 256*dir.uns + dir3.uns;
    */
    post_index(PC,mp,indice,&dir3);
    escribir_mp(dato,mp,dir3);
    //PC[0].uns++; 
   }
   //PC OK
   int ld_post_indx(union tipo_palabra16* PC, union tipo_palabra8* dato, union tipo_palabra8* indice,
                  union tipo_palabra8* SR,union tipo_palabra8* mp)
                  
   {union tipo_palabra8 dir;
    union tipo_palabra16 dir2;
    union tipo_palabra16 dir3;
    
    /*PC[0].uns++;           //Se lee la primera dir
    leer_mp(&dir,mp,PC[0]);
    dir2.uns = dir.uns;
               
    leer_mp(&dir,mp,dir2);
    dir3.uns = (dir.uns + indice[0].uns);//%256; //Parte baja la dir
    
    dir2.uns++;
    leer_mp(&dir,mp,dir2); //Parte alta
    dir3.uns = 256*dir.uns + dir3.uns;
    */
    post_index(PC,mp,indice,&dir3);
    leer_mp(dato,mp,dir3);
    //PC[0].uns++; 
   
    if (dato[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dato[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);                   
   }                                                         
   
   //PC OK
   int t_a2b(union tipo_palabra16* PC, union tipo_palabra8* orig, union tipo_palabra8* dest, 
          union tipo_palabra8* SR, union tipo_palabra8* mp)
          
   {dest[0].uns = orig[0].uns;
    PC[0].uns++;
    
    if (dest[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (dest[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
   
   }   
  
   //OPRACIONES DE PILA 
    //PC OK   
int push(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SP, 
         union tipo_palabra8* mp)
         
     {PC[0].uns++;
      mp[0x100 + SP[0].uns].uns = Reg[0].uns;
      SP[0].uns--;
     }
     
int push_sr(union tipo_palabra16* PC, union tipo_palabra8* Reg, union tipo_palabra8* SP, 
         union tipo_palabra8* mp)
         
     {PC[0].uns++;
      mp[0x100 + SP[0].uns].uns = Reg[0].uns | 0x30;
      SP[0].uns--;
     }
                                           
     //PC OK
int pop_sr(union tipo_palabra16* PC, union tipo_palabra8* SR, union tipo_palabra8* SP, 
         union tipo_palabra8* mp)
    
    {PC[0].uns++;
     SP[0].uns++;
     SR[0].uns = mp[0x100 + SP[0].uns].uns | 0x30;  //NESTRESS
     //SR[0].uns = mp[0x100 + SP[0].uns].uns & 0xcf;  //NESSTRESS APAO 2.
    
     }   
     
    //PC OK
int pop_a(union tipo_palabra16* PC, union tipo_palabra8* A, union tipo_palabra8* SR, 
         union tipo_palabra8* SP, union tipo_palabra8* mp)
    
    {PC[0].uns++;
     SP[0].uns++;
     A[0].uns = mp[0x100 + SP[0].uns].uns;
    
    if (A[0].uns == 0) poner_bit(1,1,SR);
    else poner_bit(1,0,SR);
   
    if (A[0].sig < 0) poner_bit(7,1,SR);
    else poner_bit(7,0,SR);
    }                                                                          
