#include "palabras.c"
#include "rw_mp.h"

inline int inmediato(union tipo_palabra16* PC, union tipo_palabra8* mp,
                     union tipo_palabra8* dato)
  {
        PC[0].uns++;
        leer_mp(dato,mp,PC[0]);
        PC[0].uns++;
  }
  
  inline int zero_page(union tipo_palabra16* PC, union tipo_palabra8* mp,
                     union tipo_palabra16* dir_ef)
  
  {
  
   PC[0].uns++; 
   leer_mp(&dir_ef->B.l,mp,PC[0]);
   dir_ef[0].uns &= 0x00ff;
   PC[0].uns = PC[0].uns + 1;
  
  }
  
  
  inline int absoluto(union tipo_palabra16* PC, union tipo_palabra8* mp,
                     union tipo_palabra16* dir_ef)
  
  {
   /*union tipo_palabra8 dir;  IMPLEMENTACION ANTIGUA
    //union tipo_palabra16 dir2;
    
    PC[0].uns++;
    leer_mp(&dir,mp,PC[0]);
    dir_ef[0].uns = dir.uns;
    
    PC[0].uns++;
    leer_mp(&dir,mp,PC[0]);
    dir_ef[0].uns = 256*dir.uns + dir_ef[0].uns;
    PC[0].uns++;
    */
    
    PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir_ef->B.l,mp,PC[0]);
    
    PC[0].uns++;
    leer_mp(&dir_ef->B.h,mp,PC[0]);
    dir_ef[0].uns &= 0xffff;
    PC[0].uns++;
  }  
  
  inline int post_index(union tipo_palabra16* PC, union tipo_palabra8* mp,
                     union tipo_palabra8* indice, union tipo_palabra16* dir_ef)
     {
        union tipo_palabra8 aux;
        union tipo_palabra16 dir;
        
        PC[0].uns++;
        leer_mp(&aux,mp,PC[0]);
        PC[0].uns++;
        //En AUX tengo ahora 0x04.
        dir.uns = aux.uns;
        leer_mp(&aux,mp,dir);
        
        dir_ef[0].uns = (aux.uns + indice[0].uns);// % 256;
        dir.uns++;
        
        //printf("%x\n", dir2.uns);
        leer_mp(&aux,mp,dir);
        dir_ef[0].uns = dir_ef[0].uns + 256*aux.uns;
     }
     
  inline int indexed(union tipo_palabra16* PC, union tipo_palabra8* mp,
                     union tipo_palabra8* indice, union tipo_palabra16* dir_ef)
     {union tipo_palabra8 dir;
         
     PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir_ef[0].uns = (dir.uns + indice[0].uns);// % 256;
    
    PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir_ef[0].uns = (256*dir.uns + dir_ef[0].uns) % 0x10000;  //NESTRESS
    
    PC[0].uns++;
         
      }    
      
    inline int zindexed(union tipo_palabra16* PC, union tipo_palabra8* mp,
                     union tipo_palabra8* indice, union tipo_palabra16* dir_ef)
    {union tipo_palabra8 dir;
        
     PC[0].uns++;           //Se lee la parte baja
    leer_mp(&dir,mp,PC[0]);
    dir_ef[0].uns = (dir.uns + indice[0].uns) % 256; 
    PC[0].uns++;   
    }    
    
   inline int dpre_index(union tipo_palabra16* PC, union tipo_palabra8* mp,
                     union tipo_palabra8* indice, union tipo_palabra16* dir_ef)
                     {
                       union tipo_palabra8 dir;
                       union tipo_palabra16 dir2;
                       
                         
                     PC[0].uns++;           //Se lee la parte baja
                     leer_mp(&dir,mp,PC[0]);
                     dir2.uns = (dir.uns + indice[0].uns) % 256; //CAMBIO PARA NESTRESS
               
                     leer_mp(&dir,mp,dir2);
                     dir_ef[0].uns = dir.uns;
                     dir2.uns++; 
    
                    leer_mp(&dir,mp,dir2);
                    dir_ef[0].uns = 256*dir.uns + dir_ef[0].uns;
                    PC[0].uns++;
                         
                     }    
