#include "palabras.c"
#include "op_palabras.h"
#include "constantes.h"

#define TCPU_MP 0x10000 //Esto no SE SI es CIERTO

  int leer_vram (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir, int mir)
  
      {
       switch(mp[MAPPER].uns)
         {
          case 0:   
          leer_vram0(dato,mp,dir,mir);
          break;
          
          case 3:
          if (mp[MAP2_3_BL].uns > mp[CHR_BL].uns-1) mp[MAP2_3_BL].uns = mp[CHR_BL].uns-1; //(COYUNTURAL)
          if (mp[MAP2_3_BL].uns == 0) leer_vram0(dato,mp,dir,mir);   
          else if (dir.uns <= 0x2000) dato[0] = mp[(mp[MAP2_3_BL].uns-1)*0x2000 + 0x14000 + dir.uns];  
          else  leer_vram0(dato,mp,dir,mir);
          break;        
          
          case 1:
          if (mp[CHR_BL].uns == 0) leer_vram0(dato,mp,dir,(mp[MAP1_REG0].uns & 0x01));   
          else if (dir.uns < 0x2000) leer_vram1(dato,mp,dir,(mp[MAP1_REG0].uns & 0x01));
          else leer_vram0(dato,mp,dir,(mp[MAP1_REG0].uns & 0x01));
          break;
          
          default:
          leer_vram0(dato,mp,dir,mir);          
          break; 
          }      
          
      }    
    
  int leer_vram0 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir, int mir)
  
      {   
       dir.uns = dir.uns % 0x4000; //Para que no se salga de rango
       
       if ((dir.uns >= 0x3000) && (dir.uns < 0x3F00)) //Mirror R
          {dir.uns = dir.uns - 0x1000;}
      
       switch (mp[MIR].uns)
          {case 1: //Vertical
           if ((dir.uns >= 0x2800) && (dir.uns < 0x2C00))
           dato[0] = mp[dir.uns - 0x800 + TCPU_MP];
           else if ((dir.uns >= 0x2C00) && (dir.uns < 0x3000))
           dato[0] = mp[dir.uns - 0x800 + TCPU_MP];
           else if ((dir.uns >= 0x3F00) && (dir.uns < 0x3F1F)) //En la paleta.
             {
              //if (dir.uns % 4 == 0) dato[0] = mp[0x3F00 + TCPU_MP]; //POR EL Mirrorring
              //else dato[0] = mp[dir.uns + TCPU_MP];
               if ((dir.uns % 4 == 0) && (dir.uns >= 0x3f10)) dato[0] = mp[dir.uns - 0x10 + TCPU_MP]; //POR EL Mirrorring
              else dato[0] = mp[dir.uns + TCPU_MP];
              }
           else
           dato[0] = mp[dir.uns + TCPU_MP];
           break;
           
           case 0: //Horizontal
           if ((dir.uns >= 0x2800) && (dir.uns < 0x2C00))
           dato[0] = mp[dir.uns - 0x400 + TCPU_MP];
           else if ((dir.uns >= 0x2C00) && (dir.uns < 0x3000))
           dato[0] = mp[dir.uns - 0x800 + TCPU_MP];
           else if ((dir.uns >= 0x2400) && (dir.uns < 0x2800))
           dato[0] = mp[dir.uns - 0x400 + TCPU_MP];
           else if ((dir.uns >= 0x3F00) && (dir.uns < 0x3F1F)) //En la paleta.
             {
              //if (dir.uns % 4 == 0) dato[0] = mp[0x3F00 + TCPU_MP]; //POR EL Mirrorring
              //else dato[0] = mp[dir.uns + TCPU_MP];
               if ((dir.uns % 4 == 0) && (dir.uns >= 0x3f10)) dato[0] = mp[dir.uns - 0x10 + TCPU_MP]; //POR EL Mirrorring
              else dato[0] = mp[dir.uns + TCPU_MP];
              }
           else
           dato[0] = mp[dir.uns + TCPU_MP];
           break;
           default:
           break;
           }
      
      }
  
    int leer_vram1 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir, int mir)
     {
      if ((mp[MAP1_REG0].uns & 0x10) == 0)//SWAP 8k
       {if ((mp[MAP1_REG1].uns & 0x0f) == 0)
                 leer_vram0(dato,mp,dir,mir);  
        else {dato[0] = mp[0x14000 +0x4000*(mp[PRG_BL].uns-2)+ dir.uns + ((mp[MAP1_REG1].uns & 0x0f)-1)*0x2000];        
              }
       }
       
      else //SWAP 4k
       {
           //printf("es 4k\n");
           
           if (dir.uns < 0x1000) //Cotillear REG1
            { if ((mp[MAP1_REG1].uns/* & 0x0f*/) == 0) leer_vram0(dato,mp,dir,mir); 
              else 
               dato[0] = mp[0x14000 +0x4000*(mp[PRG_BL].uns-2)+ dir.uns + ((mp[MAP1_REG1].uns/* & 0x0f*/)-2)*0x1000];
             }    
           else //Cotillear REG2
            { if ((mp[MAP1_REG2].uns/* & 0x0f*/) == 1) leer_vram0(dato,mp,dir,mir); 
              else dato[0] = mp[0x14000 +0x4000*(mp[PRG_BL].uns-2)+ dir.uns + ((mp[MAP1_REG2].uns/* & 0x0f*/)-2)*0x1000 - 0x1000];
            }    
       }    
              
     }    

    int escribir_vram (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir, int mir)
      {
        switch(mp[MAPPER].uns)
         {
          case 0:   
          escribir_vram0(dato,mp,dir,mir);
          break;
          
          case 3:
          if (mp[MAP2_3_BL].uns == 0) escribir_vram0(dato,mp,dir,mir);   
          else //leer_vram3(dato,mp,dir,mir);   
            escribir_vram0(dato,mp,dir,mir);
          break;
          
          default:
          escribir_vram0(dato,mp,dir,mir);          
          break;    
         }      
      }    
  
  int escribir_vram0 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir, int mir)
  
            {
        /*    if (dir.uns >= 0x4000)
              {
              printf("quieren escribir fuera de rango");
              system("pause");
              }
           */
             dir.uns = dir.uns % 0x4000; //Para que no se salga de rango
                         
             if ((dir.uns >= 0x3000) && (dir.uns < 0x3F00)) //Mirror R
            {dir.uns = dir.uns - 0x1000;}             
          
          
            switch (mp[MIR].uns)
          {case 1: //Vertical
          
           if ((dir.uns >= 0x2800) && (dir.uns < 0x2C00))
           mp[dir.uns - 0x800 + TCPU_MP] = dato[0];
           else if ((dir.uns >= 0x2C00) && (dir.uns < 0x3000))
           mp[dir.uns - 0x800 + TCPU_MP] = dato[0];
           else if ((dir.uns >= 0x3F00) && (dir.uns <= 0x3F1F)) //En la paleta.
             {
              //if (dir.uns % 4 == 0) mp[0x3F00 + TCPU_MP] = dato[0]; //POR EL Mirrorring
              //else
              //mp[dir.uns + TCPU_MP] = dato[0];
              if ((dir.uns % 4 == 0) && (dir.uns >= 0x3f10)) mp[dir.uns - 0x10 + TCPU_MP] = dato[0]; //POR EL Mirrorring
              else
              mp[dir.uns + TCPU_MP] = dato[0];
              
              }
           else
           mp[dir.uns + TCPU_MP] = dato[0];
           break;
           
           case 0: //Horizontal
           if ((dir.uns >= 0x2800) && (dir.uns < 0x2C00))
           mp[dir.uns - 0x400 + TCPU_MP] = dato[0];
           else if ((dir.uns >= 0x2C00) && (dir.uns < 0x3000))
           mp[dir.uns - 0x800 + TCPU_MP] = dato[0];
           else if ((dir.uns >= 0x2400) && (dir.uns < 0x2800))
           mp[dir.uns - 0x400 + TCPU_MP] = dato[0];
           else if ((dir.uns >= 0x3F00) && (dir.uns <= 0x3F1F)) //En la paleta.
             {
              //if (dir.uns % 4 == 0) mp[0x3F00 + TCPU_MP] = dato[0]; //POR EL Mirrorring
              //else
              //mp[dir.uns + TCPU_MP] = dato[0];
              if ((dir.uns % 4 == 0) && (dir.uns >= 0x3f10)) mp[dir.uns - 0x10 + TCPU_MP] = dato[0]; //POR EL Mirrorring
              else
              mp[dir.uns + TCPU_MP] = dato[0];
              }
           else
           mp[dir.uns + TCPU_MP] = dato[0];
           break;
           default:
           break;
           }
      
      }    
      
      int leer_mp_ppu (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)

    {union tipo_palabra16 dir_aux;
    
     if (dir.uns == 0x2002)
        { 
          //Esta linea no debe estar bien.
          //mp[0x2002].uns = (mp[0x2002].uns | (mp[WR_VRAM].uns*16));
          
          dato[0].uns = mp[dir.uns].uns;
          poner_bit(7,0,&mp[0x2002]); //Se pone a 0 despues de leer
          poner_bit(6,0,&mp[0x2002]); //Se pone a 0 despues de leer
          mp[DIR_HI_2006].uns = 0;          //Las dir se resetean
          mp[DIR_LO_2006].uns = 0;
          mp[SELECT_2006_5].uns = 0; //Y SUPONGO q el selector tb

        }    
     else if (dir.uns == 0x2007)  //Leer DATOS EN VRAM
        {dir_aux.uns = 256*mp[DIR_HI_2006].uns + mp[DIR_LO_2006].uns; 
         dato[0].uns = mp[PIPE_PPU].uns;  //Se Adelanta 
         leer_vram(&mp[PIPE_PPU],mp,dir_aux,mp[MIR].uns);
         if ((mp[PRIMERA_LVRAM].uns == 1) && (mp[DIR_HI_2006].uns < 0x3F)) //Si es su primera lectura no avanza.
            {mp[PRIMERA_LVRAM].uns = 0; //Ya no es la primera
            
             dir_aux.uns = (dir_aux.uns + inc_rw(mp)) % 0x4000;
             mp[DIR_HI_2006].uns = dir_aux.uns/256;
             mp[DIR_LO_2006].uns = dir_aux.uns % 256;
            }
         else   //No es la primera lectura
         
         {mp[PRIMERA_LVRAM].uns = 0; //Ya no es la primera HIPOTESIS: DEF NO ES LA PRIMERA
         if (dir_aux.uns == 0x3FFF)
          dir_aux.uns = 0;
         else     
          dir_aux.uns = (dir_aux.uns + inc_rw(mp)) % 0x4000;
          
         mp[DIR_HI_2006].uns = dir_aux.uns/256;
         mp[DIR_LO_2006].uns = dir_aux.uns % 256;
         }
        }
        
     else if (dir.uns == 0x2004) //Datos SPR-RAM
        {dir_aux.uns = 256*mp[DIR_HI_2003].uns + mp[DIR_LO_2003].uns; 
         dato[0] = mp[SPR_RAM_ORG + dir_aux.uns]; 
         dir_aux.uns = dir_aux.uns + inc_rw(mp); //No estoy seguro este incremento dependa =.
         mp[DIR_HI_2003].uns = dir_aux.uns/256;
         mp[DIR_LO_2003].uns = dir_aux.uns % 256;
         
         
        }                       
    }
      
      int escribir_mp_ppu (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)

    {union tipo_palabra16 dir_aux;
    
     if (dir.uns == 0x2006)
        { 
          if (mp[SELECT_2006_5].uns == 0)
             {mp[TMPDIR_HI2006] = dato[0]; //No debe cambiarse nada aun
             mp[SELECT_2006_5].uns++;
             }
          else //si == 1
             {mp[DIR_LO_2006] = dato[0];  //Ya se actualiza todo
              mp[DIR_HI_2006] = mp[TMPDIR_HI2006];
              mp[SELECT_2006_5].uns = 0;
              mp[PRIMERA_LVRAM].uns = 1; //Todavia no ha sido la primera lectura.
             }    
          }
          
      if (dir.uns == 0x2003) //SPR RAM Dir
        { 
          if (mp[SELECT_2003].uns == 0) //Creo: Es la primera vez
             {mp[DIR_HI_2003] = dato[0];
             mp[SELECT_2003].uns++;
             }
          else //si == 1
             {mp[DIR_LO_2003] = dato[0];
              mp[SELECT_2003].uns = 0;
             }    
          }
              
      else if (dir.uns == 0x2007)  //Escribir DATOS EN VRAM
        {dir_aux.uns = 256*mp[DIR_HI_2006].uns + mp[DIR_LO_2006].uns;
         //if (dir_aux.uns >= 0x4000) dir_aux.uns = (dir_aux.uns % 0x4000); //Cuestiones de mirroning 
         //mp[TCPU_MP + dir_aux.uns] = dato[0]; 
         escribir_vram(dato,mp,dir_aux,mp[MIR].uns);
         //ESTA LINEA ES UNA HIPOTESIS
         mp[PRIMERA_LVRAM].uns = 0;  //HIPOTESIS: Ya la lectura dara bien
         //FIN HIPOTESIS
         if (dir_aux.uns == 0x3FFF)
          dir_aux.uns = 0;
         else     
          dir_aux.uns = (dir_aux.uns + inc_rw(mp));// % 0x4000;
         mp[DIR_HI_2006].uns = dir_aux.uns/256;
         mp[DIR_LO_2006].uns = dir_aux.uns % 256;
         
        } 
     
     else if (dir.uns == 0x2004) //Datos SPR-RAM
        {dir_aux.uns = 256*mp[DIR_HI_2003].uns + mp[0x855].uns;  
         mp[SPR_RAM_ORG + dir_aux.uns] = dato[0]; 
         dir_aux.uns = dir_aux.uns + inc_rw(mp);
         mp[DIR_HI_2003].uns = dir_aux.uns/256;
         mp[DIR_LO_2003].uns = dir_aux.uns % 256;
         
        }
        
     else if (dir.uns == 0x2005)  //Reg Scroll
     
        {
         if (mp[SELECT_2006_5].uns == 0) //x 0 - 255
            {mp[SCROLL_H].uns = dato[0].uns;
             mp[SELECT_2006_5].uns++; //Experimental
            //system("pause");
            }
         else
            {
             if (dato[0].uns > 239)
              mp[SCROLL_V].uns = -(255 - dato[0].uns);
             else 
              mp[SCROLL_V].uns = dato[0].uns;
              
              mp[SELECT_2006_5].uns = 0; //experimental
            
            }      //y 0-239
        }   
           
    }
